package com.blamejared.ctgui.api;

import net.minecraft.client.Minecraft;
import net.minecraft.client.gui.GuiButton;
import net.minecraft.client.renderer.GlStateManager;
import net.minecraftforge.fml.client.config.*;
import org.lwjgl.opengl.GL11;

import java.awt.*;
import java.util.List;

public class CheckButton extends GuiCheckBox {

    protected GuiBase parent;
    protected List<GuiButton> incompatible;

    protected int backgroundSize = 100;

    public CheckButton(GuiBase parent, int id, int xPos, int yPos, String displayString, boolean isChecked) {
        super(id, xPos, yPos, displayString, isChecked);
        this.parent = parent;
    }


    public int getBackgroundSize() {
        return backgroundSize;
    }

    public void setBackgroundSize(int backgroundSize) {
        this.backgroundSize = backgroundSize;
    }

    public List<GuiButton> getIncompatible() {
        return incompatible;
    }

    public void setIncompatible(List<GuiButton> incompatible) {
        this.incompatible = incompatible;
    }

    /**
     * Draws this button to the screen.
     */
    public void drawButton(Minecraft mc, int mouseX, int mouseY) {
        if(this.field_146125_m) {
            this.field_146123_n = mouseX >= this.field_146128_h && mouseY >= this.field_146129_i && mouseX < this.field_146128_h + func_146117_b() && mouseY < this.field_146129_i + this.field_146121_g;
            GlStateManager.func_179141_d();
            GL11.glColor4d(1, 1, 1, 0);
            GuiUtils.drawGradientRect(30, this.field_146128_h - 2, this.field_146129_i - 2, this.field_146128_h + getBackgroundSize(), this.field_146129_i + field_146121_g + 2, 0x9F100010, 0x9F100010);
            GlStateManager.func_179118_c();
            GuiUtils.drawContinuousTexturedBox(field_146122_a, this.field_146128_h, this.field_146129_i, 0, 46, 11, this.field_146121_g, 200, 20, 2, 3, 2, 2, this.field_73735_i);
            this.func_146119_b(mc, mouseX, mouseY);
            int color = 14737632;

            if(packedFGColour != 0) {
                color = packedFGColour;
            } else if(!this.field_146124_l) {
                color = 10526880;
            }

            if(this.isChecked()) {
                this.func_73733_a(this.field_146128_h + 2, this.field_146129_i + 2, this.field_146128_h + 11 - 2, this.field_146129_i + field_146121_g - 2, Color.cyan.darker().getRGB(), Color.cyan.darker().getRGB());
            }

            this.func_73731_b(mc.field_71466_p, field_146126_j, field_146128_h + 11 + 2, field_146129_i + 2, color);
        }
    }

    @Override
    public boolean func_146116_c(Minecraft mc, int mouseX, int mouseY) {
        if(this.field_146124_l && this.field_146125_m && mouseX >= this.field_146128_h && mouseY >= this.field_146129_i && mouseX < this.field_146128_h + this.field_146120_f && mouseY < this.field_146129_i + this.field_146121_g) {
            setIsChecked(!isChecked());
            return true;
        }
        return false;
    }


    public void setIsChecked(boolean isChecked) {
        super.setIsChecked(isChecked);
        if(isChecked()) {
            for(GuiButton but : incompatible) {
                but.field_146124_l = false;
                if(but instanceof CheckButton) {
                    ((CheckButton) but).setIsChecked(false);
                }
            }
        } else {
            for(GuiButton but : incompatible) {
                but.field_146124_l = true;
            }
        }
    }

}
