package crafttweaker.mc1120.commands;

import net.minecraft.command.ICommandSender;
import net.minecraft.util.text.*;
import net.minecraft.util.text.event.ClickEvent;
import net.minecraft.util.text.event.HoverEvent;

import static crafttweaker.mc1120.commands.ClipboardHelper.copyCommandBase;


/**
 * Created by jonas on 04.07.2017.
 */
public class SpecialMessagesChat {

    public static final ITextComponent EMPTY_TEXTMESSAGE = new TextComponentString("");

    public static ITextComponent getClickableCommandText(String message, String command, boolean runDirectly){

        Style style = new Style();
        ClickEvent click = new ClickEvent(runDirectly ? ClickEvent.Action.RUN_COMMAND : ClickEvent.Action.SUGGEST_COMMAND, command);
        style.func_150241_a(click);

        HoverEvent hoverEvent = new HoverEvent(HoverEvent.Action.SHOW_TEXT, new TextComponentString("Click to execute [\u00A76" + command + "\u00A7r]"));
        style.func_150209_a(hoverEvent);

        return new TextComponentString(message).func_150255_a(style);
    }

    public static ITextComponent getClickableBrowserLinkText(String message, String url){

        Style style = new Style();
        ClickEvent click = new ClickEvent(ClickEvent.Action.OPEN_URL, url);
        style.func_150241_a(click);
        style.func_150238_a(TextFormatting.AQUA);
        style.func_150228_d(true);

        HoverEvent hoverEvent = new HoverEvent(HoverEvent.Action.SHOW_TEXT, new TextComponentString("Click to Open [\u00A76" + url + "\u00A7r]"));
        style.func_150209_a(hoverEvent);

        return new TextComponentString(message).func_150255_a(style);
    }

    public static ITextComponent getFileOpenText(String message, String filepath){

        Style style = new Style();
        ClickEvent click = new ClickEvent(ClickEvent.Action.OPEN_FILE, filepath);
        style.func_150241_a(click);

        HoverEvent hoverEvent = new HoverEvent(HoverEvent.Action.SHOW_TEXT, new TextComponentString("Click to open [\u00A76" + filepath + "\u00A7r]"));
        style.func_150209_a(hoverEvent);

        return new TextComponentString(message).func_150255_a(style);
    }

    public static ITextComponent getNormalMessage(String message){
        return new TextComponentString(message);
    }

    public static ITextComponent getLinkToCraftTweakerLog(String message, ICommandSender sender){
        if (sender.func_130014_f_().field_72995_K){
            return getNormalMessage(message + "\nSee \u00A7acrafttweaker.log \u00A7rin your minecraft dir");
        }else {
            return getFileOpenText(message + "\nSee \u00A7acrafttweaker.log \u00A7r[\u00A76Click here to open\u00A7r]", CTChatCommand.CRAFTTWEAKER_LOG_PATH);
        }
    }

    public static ITextComponent getCopyMessage(String message, String copyMessage){
        Style style = new Style();
        ClickEvent click = new ClickEvent(ClickEvent.Action.RUN_COMMAND, copyCommandBase + copyMessage);
        style.func_150241_a(click);

        HoverEvent hoverEvent = new HoverEvent(HoverEvent.Action.SHOW_TEXT, new TextComponentString("Click to copy [\u00A76" + copyMessage + "\u00A7r]"));
        style.func_150209_a(hoverEvent);

        return new TextComponentString(message).func_150255_a(style);
    }
}
